import { FC } from "react";
import { EffectReducer, StateReducer } from "react-use-bireducer";
import { PinFieldDefaultProps as DefaultProps, PinFieldProps as Props, PinFieldNotifierProps as NotifierProps, PinFieldState as State, PinFieldAction as Action, PinFieldEffect as Effect } from "./pin-field.types";
export declare const NO_EFFECT: Effect[];
export declare const PROP_KEYS: string[];
export declare const HANDLER_KEYS: string[];
export declare const IGNORED_META_KEYS: string[];
export declare const defaultProps: DefaultProps;
export declare function defaultState(props: Pick<DefaultProps, "validate" | "length">): State;
export declare function getPrevFocusIdx(currFocusIdx: number): number;
export declare function getNextFocusIdx(currFocusIdx: number, lastFocusIdx: number): number;
export declare function isKeyAllowed(predicate: DefaultProps["validate"]): (key: string) => boolean;
export declare const stateReducer: StateReducer<State, Action, Effect>;
export declare function useEffectReducer({ refs, ...props }: NotifierProps): EffectReducer<Effect, Action>;
export declare const PinField: FC<Props>;
export default PinField;
